> This page is for version v2 (default).
> For other versions, use one of these documentation indexes:
> - v2 (default): https://developers.clearpay.co.uk/v-2/llms.txt
> - v1: https://developers.clearpay.co.uk/v-1/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.clearpay.co.uk/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.clearpay.co.uk/_mcp/server.

# Reverse Payment By Token

POST https://global-api-sandbox.afterpay.com/v2/payments/token:{token}/reversal

This endpoint performs a reversal of the checkout that is used to initiate the Clearpay payment process. This will cancel the order asynchronously as soon as it is created without the need of an additional call to the void or refund endpoint. In order for a payment to be eligible, the order must be in an Auth-Approved or Captured state and must be issued within 10 minutes of the order being created.

If this is called after a timeout is received from v2/payments/auth and v2/payments/auth eventually completes successfully, the order will get voided shortly after it’s created.

If this is called after a timeout is received from v2/payments/capture and v2/payments/capture eventually completes successfully, the order will end up in a REVERSED state. This is similar to a call to the v2/payments/refund endpoint except that merchant fees are not paid to Clearpay and the capture and refund will not show up in the settlement file.

## Successful Response (204)

Returns no content in the response.

## Connection Timeouts

| Timeout | Time (Seconds) |
| :------ | :------------- |
| Open    | 10             |
| Read    | 70             |

## Errors

In addition to the [PUT/POST Errors](/put-post-errors) applicable to all POST endpoints, the following errors are specific to Reverse Payment By Token:

| HTTP Status Code             | errorCode             | Description                                          |
| :--------------------------- | :-------------------- | :--------------------------------------------------- |
| **402**  Payment Required    | `invalid_token`       | Invalid token                                        |
| **412**  Precondition Failed | `precondition_failed` | Payment reversal previously processed                |
| **412**  Precondition Failed | `precondition_failed` | Payment not eligible for a reversal                  |
| **412**  Precondition Failed | `precondition_failed` | Order outside reversal window                        |
| **412**  Precondition Failed | `precondition_failed` | Order in pending reversal, no captures/auth accepted |

Reference: https://developers.clearpay.co.uk/api-reference/reverse-payment-by-token

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `token` (string, required) — The token of the checkout to be reversed (voided).

### Headers

- `Accept` (string, optional, default: application/json)

## Examples

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal"

headers = {
    "User-Agent": "User-Agent"
}

response = requests.post(url, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {'User-Agent': 'User-Agent', Authorization: `Basic ${credentials}`}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal', [
  'headers' => [
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/token:token/reversal")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```